
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include "sf_convert.h"
#include "util.h"


extern char  *CCP4, *CGI_PATH,*URL_USERS_DATA, *USERS_DATA, EXECUTE[512];
extern int DATA_SET, DATA_PHS;

void html_wwpdb_header(FILE *fw, int id)
//print the header of wwpdb style form. id=1, for header; id=2 for tail
 
{
    const char *str1="  \n\
<html> \n\
<head> \n\
<meta charset=\"UTF-8\" /> \n\
<title>SF-Tool</title> \n\
<meta name=\"description\" content=\"SF-tool is to used to (1) convert various structure factor fromats,  \n\
(2) perform validation of structure factors against model. \" /> \n\
<meta name=\"keywords\" content=\"mmCIF, CIF, MTZ, CNS, Xplor, HKL2000, Scalepack,  \n\
Dtrek, TNT,  SHELX, SAINT, EPMR, XSCALE, XPREP, XTALVIEW, X-GEN, XENGEN, MULTAN, MAIN \" /> \n\
<link href=\"http://pdb-d-linux-4.rutgers.edu/auto-check/wwpdb_css/site.css\" rel=\"stylesheet\" type=\"text/css\" media=\"all\" /> \n\
</head> \n\
<body> \n\
\n\
<div class=\"container\"> \n\
  <header class=\"container_12\"> \n\
    <div class=\"logo\"> \n\
      <a href=\"http://www.wwpdb.org/\"><img src=\"http://pdb-d-linux-4.rutgers.edu/auto-check/wwpdb_img/wwpdb_logo.gif\" alt=\"SF-tool Logo\" width=\"187\" height=\"58\" /></a> \n\
    </div> \n\
    <div class=\"topnav frht bg-green ui-corner-all pall\"> \n\
        	<a href=\"index.html\" class=\"ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only\" title=\"Home\"><span class=\"ui-button-text\">Home</span></a> \n\
            <a href=\"version.html\" class=\"ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only\" title=\"Version\"></span><span class=\"ui-button-text\">Version</span></a> \n\
             <a href=\"documentation.html\" class=\"ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only\" title=\"Documentation\"><span class=\"ui-button-text\">Documentation</span></a> \n\
            <div class=\"clear\">&nbsp;</div> \n\
    </div> \n\
 \n\
    <div class=\"headercontent prefix_1\"><h1> Structure Factor Conversion and Validation </h1></div> \n\
    <div class=\"clear\">&nbsp;</div> \n\
    <div class=\"seperator\"></div> \n\
  </header> \n\
";
    
    const char *str2 = "\n\
  <footer class=\"container_12 ui-corner-all\"> \n\
    <p>&copy; <a href=\"http://home.rcsb.org\">RCSB PDB</a></p> \n\
  </footer> \n\
</div> \n\
</body> \n\
</html> \n\
";

    if (id ==1){
        fprintf(fw, "%s", str1);
    }else{
        fprintf(fw, "%s", str2);
    }
    
}


void html_rcsb_header(FILE *fw, int id)
{
    const char *str1=" <html xmlns=\"http://www.w3.org/1999/xhtml\"> \n\
<head>\n\
<title>SF-Tool</title>\n\
<meta content=\"text/html; charset=iso-8859-1\" http-equiv=\"Content-Type\"/>\n\
     <link rel=\"stylesheet\" type=\"text/css\" href=\"http://pdb-d-linux-4.rutgers.edu/auto-check/styles/twoColDp.css\" />\n\
     <link rel=\"stylesheet\" type=\"text/css\" href=\"http://pdb-d-linux-4.rutgers.edu/auto-check/styles/general.css\" />\n\
</head>\n\
<body class=\"twoColDp\">\n\
\n\
<div id=\"container\">\n\
<div id=\"header\">\n\
    <div class=\"logo\"><a href=\"http://www.rcsb.org/\" target=\"_blank\" ><img src=\"http://pdb-d-linux-4.rutgers.edu/auto-check/icons-local/pdblogo.gif\" alt=\"RCSB PDB\" border=\"0\" /></a>\n\
    </div>\n\
    <div class=\"headercontent\">  \n\
  	<a href=\"http://www.wwpdb.org/\" target=\"_blank\"><img alt=\"A Member of the wwPDB\" src=\"http://pdb-d-linux-4.rutgers.edu/auto-check/icons-local/wwpdb.gif\" width=\"191\" height=\"15\" border=\"0\"></a>\n\
    <br/><span>An Information Portal to Biological Macromolecular Structures</span>\n\
    </div>\n\
    <div class=\"logolinks\">\n\
    	&nbsp;\n\
     	<a href=\"http://www.rcsb.org/\" alt=\"RCSB PDB\" target=\"_blank\">RCSB PDB</a>\n\
     	&nbsp;|&nbsp;\n\
     	<a href=\"mailto:deposit@deposit.rcsb.org\">Contact Us <img src=\"http://pdb-d-linux-4.rutgers.edu/auto-check/icons-local/email.png\" alt=\"Contact Us\" align=\"bottom\" border=\"0\"/></a>\n\
    </div>\n\
    <div class=\"mainlinks\">\n\
        <img src=\"http://pdb-d-linux-4.rutgers.edu/auto-check/icons-local/img1.gif\" alt=\"\" />\n\
    	<a href=\"http://deposit.rcsb.org\"><span>Validation and Deposition Services Home</span></a> \n\
    </div>\n\
</div>\n\
<div id=\"mainContent\">\n\
";
    
    const char *str2 = "\n\
</div><!-- end #mainContent -->\n\
\n\
<br class=\"clearfloat\" />\n\
 <!-- This clearing element should immediately follow the #mainContent div in order to \n\
        force the #container div to contain all child floats -->\n\
\n\
<div id=\"footer\">\n\
	<div class=\"spacer1\"></div>\n\
	<div class=\"spacer2 b i\"><a href=\"http://home.rcsb.org\" target=\"_blank\">&copy RCSB PDB</a></div>\n\
</div>\n\
\n\
<div id=\"footnote\">\n\
<p>\n\
<span class=\"crimson\">Questions, comments, and suggestions should be sent to </span>\n\
<a href=\"mailto:deposit@deposit.rcsb.org\">deposit@deposit.rcsb.org</a>.\n\
</p>\n\
</div>\n\
\n\
</div><!-- end #container -->\n\
";
    
        

    if (id ==1){
        fprintf(fw, "%s", str1);
    }else{
        fprintf(fw, "%s", str2);
    }
    
    
}


void get_mtz_infor(char *inpfile, char *path, char *pdb_id_inp)
{
    
    FILE  *fout;
    char **label_ptr=NULL, **type_ptr=NULL, **set_ptr=NULL;
    char outfile[512], file_new[256], label[2000], type[256], sets[256];
    int i, nlabel=0, ntype=0,nsets=0, start, end;
    

    (DATA_PHS>0)? strcpy(outfile,"get_mtz_infor_phs.html") : strcpy(outfile,"get_mtz_infor.html");
    
    if((fout=fopen(outfile, "w"))==NULL){
        printf("Error, no written permission for file get_mtz_infor.html!\n");
        exit(0);
    }
    get_type_label_sets(inpfile, label, type, sets);
    
    label_ptr = string_token(label," ", &nlabel);
    type_ptr = string_token(type," ", &ntype);
    set_ptr = string_token(sets," ", &nsets);
    for(i=0;i<nsets; i++){
//        printf("what is labels = %d %9s %9s %9s\n", i, label_ptr[i],type_ptr[i],set_ptr[i]);
    }
    
    if(nlabel != ntype || nlabel != nsets ||nlabel==0){
        printf("Error! There is a problem with data set (Can not open the input SF file).\n");
        return;
    }

//    html_rcsb_header(fout, 1);
//    html_wwpdb_header(fout, 1);
    

//write HTML
//    fprintf(fout, "<HTML> \n <Head>\n <TITLE> Semi-auto conversion of MTZ to mmCIF format</TITLE>\n </Head>\n");
//    fprintf(fout, "<CENTER> <h2> Semi-auto conversion of MTZ to mmCIF format</h2></CENTER>\n");
//    fprintf(fout, " <p> \n");
    
//    fprintf(fout, "<form ENCTYPE=\"multipart/form-data\" Method=\"post\" Action=\"%sget_mtz_infor.cgi\">\n", CGI_PATH);
    fprintf(fout, "<form ENCTYPE=\"multipart/form-data\" Method=\"post\" Action=\"%sconvert_man.py\">\n",CGI_PATH);


    fprintf(fout, "<li> Match the appropriate SF parameters with the column labels used in your file by selecting from the pulldown menus. Then select RUN to perform a complete DATA TYPE conversion from CNS or MTZ format to mmCIF format. </li>\n");
    
    
    fprintf(fout, "<li> View data items from the uploaded MTZ header file <a href = \"%s/%s/mtzdmp.log\"  TARGET=\"other\">  (TXT) </A>,\n",URL_USERS_DATA, path);
    fprintf(fout, " View MTZ format details (from  <a href = \"http://www.ccp4.ac.uk/dist/html/mtzformat.html \" TARGET=\"other\"> CCP4 </a>). </li>\n");
    

    fprintf(fout, "<li> If you used default value (0) for free_R set, <b> do not </b> select FreeR value.<br><br></li>  \n");


//    
//    fprintf(fout, "<tr><td colspan=3 bgcolor=\"khaki\"><font size=4 color=\"#000000\"> <center><b>\n");
//    fprintf(fout, "Number of data set  <INPUT TYPE=TEXT NAME=\"data_set\" SIZE=2 VALUE=%d > </b></center></td></tr> \n",DATA_SET );

    
    start=0;
    
    end= DATA_SET;
    if(DATA_PHS>0) {
        start=1;
        end=DATA_SET+1;
    }
    for(i=start; i<end; i++){
        write_mtz_data_4_html(fout, set_ptr, label_ptr, nlabel, type_ptr,i);
    }
    fprintf(fout, "<INPUT TYPE=SUBMIT NAME=\"submit\" VALUE=\"RUN\"> \n");
    fprintf(fout, "<INPUT TYPE=RESET VALUE= \"RESET\">\n");
    fprintf(fout, "</center><p>\n");
    fprintf(fout, "\n");
    
//    html_rcsb_header(fout, 2);
//    html_wwpdb_header(fout, 2);


    if(strstr(inpfile, "dir_") && strchr(inpfile, '/')){ // rid of path
        strcpy(file_new, strstr(inpfile, "dir_")+4);
        if(strchr(file_new, '/')){
            strcpy(file_new, strchr(file_new, '/')+1);
        }    
    }else{
        strcpy(file_new,inpfile);
    }
    
    fprintf(fout, "<input type=\"hidden\"  name=\"pdb_id\" value=\"%s\"> \n", pdb_id_inp);
    fprintf(fout, "<input type=\"hidden\"  name=\"infile\" value=\"%s\"> \n", file_new);
    fprintf(fout, "<input type=\"hidden\"  name=\"user_dir\" value=\"%s\"> \n", path);
    
    fprintf(fout, "<input type=\"hidden\"  name=\"url_users_data\" value=\"%s\"> \n",URL_USERS_DATA);
    fprintf(fout, "<input type=\"hidden\"  name=\"users_data\" value=\"%s\"> \n",USERS_DATA);
    fprintf(fout, "<input type=\"hidden\"  name=\"sf_convert\" value=\"%s\"> \n",EXECUTE);
    fprintf(fout, "<input type=\"hidden\"  name=\"ccp4\" value=\"%s\"> \n",CCP4);
    fprintf(fout, "<input type=\"hidden\"  name=\"data_set\" value=\"%d\"> \n",DATA_SET);
    fprintf(fout, "<input type=\"hidden\"  name=\"html_type\" value=\"mtz\"> \n");
    
    fprintf(fout, "\n</form>\n");
//    fprintf(fout, "</BODY> </HTML>\n");
                                                                                
    fclose(fout);
    
    if(nlabel>0)free_memory_2d(label_ptr,nlabel);
    if(ntype>0)free_memory_2d(type_ptr,ntype);
    if(nsets>0)free_memory_2d(set_ptr,nsets);
}

void write_mtz_data_4_html(FILE *fout, char **sets,  char **items, int nitem, char **type, int i)
{
    char  align[40];
    
//    fprintf(fout, "<center>\n <table align=center cellpadding=8 bgcolor=\"lightsteelblue\">\n");
    fprintf(fout, "<center>\n <table align=center cellpadding=8 bgcolor=\"#CEF6F5\">\n");
    fprintf(fout, "<b><p>Data Column Selector (Data Set %d) </b>\n", i+1);
    
    strcpy(align,"center");
    fprintf(fout, "<tr>\n");
    fprintf(fout, "<td align=center><b><font color=\"blue\"> SF PARAMETER </font>  <b></td>\n");
    fprintf(fout, "<td align=center><b><font color=\"blue\"> COLUMN USED IN<br> UPLOADED FILE  </font>  <b></td>\n");
    fprintf(fout, "<td align=center><b><font color=\"blue\"> SF PARAMETER </font>  <b></td>\n");
    fprintf(fout, "<td align=center><b><font color=\"blue\"> COLUMN USED IN<br> UPLOADED FILE  </font>  <b></td>\n");
    fprintf(fout, " </tr>\n");
    
    
// Fp and SigmaFP     
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Native data amplitude (FP):", "fp", i, items, nitem,type,sets);
    write_data_column(fout, align, "Sigma (SIGFP):", "sigfp", i, items, nitem,type,sets); 
    fprintf(fout, " </tr>\n");

//   Mean intensity sigma(IMEAN).
        
    fprintf(fout, "<tr>\n");
    
    write_data_column(fout, align, "Mean intensity (I):", "i", i, items, nitem,type,sets);
    write_data_column(fout, align, "Sigma (SIGI): ", "sigi", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");

// FreeR test    
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Free R flag :", "free", i, items, nitem,type,sets);
    write_data_column(fout, align, "FreeR value:", "freer", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");

// I(+) and SigmaI(+)
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Intensity (I(+))", "iplus", i, items, nitem,type,sets);
    write_data_column(fout, align, "Sigma (SIGI(+))", "sigiplus", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");

    

// I(-) and SigmaI(-)     
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Intensity (I(-))", "ineg", i, items, nitem,type,sets);
    write_data_column(fout, align, "Sigma  (SIGI(-))", "sigineg", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");
       
    
// F(+) and SigmaF(+)
       
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Amplitude (F(+))", "fplus", i, items, nitem,type,sets);
    write_data_column(fout, align, "Sigma (SIGF(+))", "sigfplus", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");

    

// F(-) and SigmaF(-)     
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Amplitude (F(-))", "fneg", i, items, nitem,type,sets);
    write_data_column(fout, align, "Sigma  (SIGF(-))", "sigfneg", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");
       

//  Calculated F (FC).Calculated Phase (PHIC)
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Calculated F (FC):", "fc", i, items, nitem,type,sets);
    write_data_column(fout, align, "Calculated Phase (PHIC):", "phic", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");


//  ABCD H/L coefficients (HLA,HLB,HLC,HLD)
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "H/L coefficients (HLA):", "hla", i, items, nitem,type,sets);
    write_data_column(fout, align, "H/L coefficients (HLB):", "hlb", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");

    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "H/L coefficients (HLC):", "hlc", i, items, nitem,type,sets);
    write_data_column(fout, align, "H/L coefficients (HLD):", "hld", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");


// DP and SigmaDP (Anomalous difference for native data)    
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Anomalous difference(DP)", "dp", i, items, nitem,type,sets);
    write_data_column(fout, align, "Sigma  (SIGDP)", "sigdp", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");

//  figure of merit  (FOM) Averaged phase (PHIB)
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Figure of merit  (FOM):", "fom", i, items, nitem,type,sets);
    write_data_column(fout, align, "Averaged phase (PHIB):", "phib", i, items, nitem,type,sets);
    fprintf(fout, " </tr>\n");

    
    fprintf(fout, "</table>\n");
}



void write_data_column(FILE *fout, char *align, const char *item_name,const char *fname, 
                       int k, char **items,int nitem,  char **type,  char **sets)
// write item-name and corresponding field
{
    char  file_name[80];
    int i=0;
    
    sprintf(file_name,"%s_%d",fname, k+1);
    
    fprintf(fout, "<td align=%s><b>%s &nbsp <b></td>\n",align, item_name);
    fprintf(fout, "<td><SELECT NAME=\"%s\" WIDTH=10>\n", file_name);
    
    get_labels(fout, k, sets, items, type, nitem, fname);
    
//    fprintf(fout, "<OPTION VALUE=\"\">Unassigned\n");
    fprintf(fout, "<OPTION VALUE=\"\"> \n");
    
    if(!strcmp(fname, "freer")){ //chose value for freeR
        for (i=-1; i<20; i++){
            fprintf(fout, "<OPTION VALUE=\"%d\">%d\n",i, i);
        }
    }else{
        for (i=3; i<nitem; i++){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", items[i],items[i]);
        }
    }
    
    fprintf(fout, "</SELECT> </td>\n");
}





void get_labels(FILE *fout, int k, char **set_ptr, char **label_ptr,
                char **type_ptr, int ntype,  const char *fname)
/* according to various to cif 
only H, K, L, FP, SIGFP, DP, SIGDP, FC, PHIC, PHIB, FOM, 
I+, SIGI+, I-, SIGI-, FPART_BULK_S, PHIPART_BULK_S and FREE 
are accepted.
*/
{
    int  i=0;
        
        
    for(i=3; i<ntype; i++){// FOM ......
//        printf("getlable= %d  %d %d  %s \n", i, k, ntype, set_ptr[i]);
        
        if (atoi(set_ptr[ntype-1]) >1 && k != atoi(set_ptr[i]) && k!=0) continue;
        if(type_ptr[i][0] == 'I' && !strcmp(fname, "free")){
            if(strstr_case(label_ptr[i], "free") ||
               strstr_case(label_ptr[i], "flag") ||
               strstr_case(label_ptr[i], "test")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
            }
            
        }else if(type_ptr[i][0] == 'F'  && label_ptr[i][0]== 'F' && !strcmp(fname, "fp")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
                
        }else if(type_ptr[i][0] == 'Q' && strstr_case(label_ptr[i], "SIGF") && !strcmp(fname, "sigfp")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
              
        }else if(type_ptr[i][0] == 'J' &&  label_ptr[i][0]== 'I'  && !strcmp(fname, "i")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
               
        }else if(type_ptr[i][0] == 'Q' &&  strstr_case(label_ptr[i], "SIGI") && !strcmp(fname, "sigi")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
                
        }else if(type_ptr[i][0] == 'W' && strstr_case(label_ptr[i], "FOM") && !strcmp(fname, "fom")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
                
        }else if(type_ptr[i][0] == 'P' && strstr_case(label_ptr[i], "PHIB") && !strcmp(fname, "phib")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
                
        }else if(type_ptr[i][0] == 'F' && (strstr_case(label_ptr[i], "FC_ALL") || strstr_case(label_ptr[i], "F-model"))&& !strcmp(fname, "fc")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if(type_ptr[i][0] == 'P' && (strstr_case(label_ptr[i], "PHIC_ALL") ||strstr_case(label_ptr[i], "PHIF-model"))  && !strcmp(fname, "phic")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if(type_ptr[i][0] == 'A' && strstr_case(label_ptr[i], "HLA") && !strcmp(fname, "hla")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if(type_ptr[i][0] == 'A' && strstr_case(label_ptr[i], "HLB") && !strcmp(fname, "hlb")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if(type_ptr[i][0] == 'A' && strstr_case(label_ptr[i], "HLC") && !strcmp(fname, "hlc")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if(type_ptr[i][0] == 'A' && strstr_case(label_ptr[i], "HLD") && !strcmp(fname, "hld")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if(type_ptr[i][0] == 'D' && !strncmp_case(label_ptr[i], "D", 1) && !strcmp(fname, "dp")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if(type_ptr[i][0] == 'Q' && strstr_case(label_ptr[i], "SIGD") && !strcmp(fname, "sigdp")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
                
        }else if( type_ptr[i][0] == 'G' && strstr(label_ptr[i], "(+)") && label_ptr[i][0]=='F' && !strcmp(fname, "fplus")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if(type_ptr[i][0] == 'L' && strstr(label_ptr[i], "(+)") && !strncmp_case(label_ptr[i], "SIGF",4) && !strcmp(fname, "sigfplus")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
                
        }else if(type_ptr[i][0] == 'G' && strstr(label_ptr[i], "(-)") && label_ptr[i][0]=='F' && !strcmp(fname, "fneg")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if(type_ptr[i][0] == 'L' && strstr(label_ptr[i], "(-)") && !strncmp_case(label_ptr[i], "SIGF",4) && !strcmp(fname, "sigfneg")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
                
        }else if((type_ptr[i][0] == 'K' && strstr(label_ptr[i], "(+)") && label_ptr[i][0]=='I') && !strcmp(fname, "iplus")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if((type_ptr[i][0] == 'M' && strstr(label_ptr[i], "(+)") && !strncmp_case(label_ptr[i], "SIGI",4)) && !strcmp(fname, "sigiplus")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
                
        }else if((type_ptr[i][0] == 'K' && strstr(label_ptr[i], "(-)") && label_ptr[i][0]=='I') && !strcmp(fname, "ineg")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
            
        }else if((type_ptr[i][0] == 'M' && strstr(label_ptr[i], "(-)") && !strncmp_case(label_ptr[i], "SIGI",4)) && !strcmp(fname, "sigineg")){
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
            break;
                                                                                                         
        }
        
        
    }
    
    
    
}

